import type { DocumentNode } from 'graphql';
import type { Observable } from 'rxjs';
import type { OperationVariables, TypedDocumentNode } from '@apollo/client/core/index.js';
import { Apollo } from './apollo';
import type { EmptyObject, MutationOptionsAlone, MutationResult } from './types';
import * as i0 from "@angular/core";
export declare abstract class Mutation<T = {}, V extends OperationVariables = EmptyObject> {
    protected readonly apollo: Apollo;
    abstract readonly document: DocumentNode | TypedDocumentNode<T, V>;
    client: string;
    constructor(apollo: Apollo);
    mutate(variables?: V, options?: MutationOptionsAlone<T, V>): Observable<MutationResult<T>>;
    static ɵfac: i0.ɵɵFactoryDeclaration<Mutation<any, any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<Mutation<any, any>>;
}
