import type { DocumentNode } from 'graphql';
import type { Observable } from 'rxjs';
import type { OperationVariables, TypedDocumentNode } from '@apollo/client/core/index.js';
import { Apollo } from './apollo';
import { EmptyObject, ExtraSubscriptionOptions, SubscriptionOptionsAlone, SubscriptionResult } from './types';
import * as i0 from "@angular/core";
export declare abstract class Subscription<T = any, V extends OperationVariables = EmptyObject> {
    protected readonly apollo: Apollo;
    abstract readonly document: DocumentNode | TypedDocumentNode<T, V>;
    client: string;
    constructor(apollo: Apollo);
    subscribe(variables?: V, options?: SubscriptionOptionsAlone<V, T>, extra?: ExtraSubscriptionOptions): Observable<SubscriptionResult<T>>;
    static ɵfac: i0.ɵɵFactoryDeclaration<Subscription<any, any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<Subscription<any, any>>;
}
